searchData={"items":[{"type":"task","title":"mix waffle","doc":"","ref":"Mix.Tasks.Waffle.html"},{"type":"task","title":"mix waffle.g","doc":"A task for generating waffle uploader modules.\n\nIf generating an uploader in a Phoenix project, your a uploader will be generated in\nlib/[APP_NAME]_web/uploaders/","ref":"Mix.Tasks.Waffle.G.html"},{"type":"task","title":"Example - mix waffle.g","doc":"mix waffle.g avatar # creates  lib/[APP_NAME]_web/uploaders/avatar.ex\n\n\nIf not generating an uploader in a Phoenix project, then you must pass the path to where the\nuploader should be generated.","ref":"Mix.Tasks.Waffle.G.html#module-example"},{"type":"task","title":"Example - mix waffle.g","doc":"mix waffle.g avatar  uploaders/avatar.ex # creates uploaders/avatar.ex","ref":"Mix.Tasks.Waffle.G.html#module-example"},{"type":"function","title":"Mix.Tasks.Waffle.G.run/1","doc":"","ref":"Mix.Tasks.Waffle.G.html#run/1"},{"type":"module","title":"Waffle.Actions.Delete","doc":"Delete files from a defined adapter.\n\nAfter an object is stored through Waffle, you may optionally remove\nit.  To remove a stored object, pass the same path identifier and\nscope from which you stored the object.\n\n    # Without a scope:\n    {:ok, original_filename} = Avatar.store(\"/Images/me.png\")\n    :ok = Avatar.delete(original_filename)\n\n    # With a scope:\n    user = Repo.get!(User, 1)\n    {:ok, original_filename} = Avatar.store({\"/Images/me.png\", user})\n    # example 1\n    :ok = Avatar.delete({original_filename, user})\n    # example 2\n    user = Repo.get!(User, 1)\n    :ok = Avatar.delete({user.avatar, user})","ref":"Waffle.Actions.Delete.html"},{"type":"function","title":"Waffle.Actions.Delete.delete/2","doc":"","ref":"Waffle.Actions.Delete.html#delete/2"},{"type":"module","title":"Waffle.Actions.Store","doc":"Store files to a defined adapter.\n\nThe definition module responds to `Avatar.store/1` which\naccepts either:\n\n  * A path to a local file\n\n  * A path to a remote `http` or `https` file\n\n  * A map with a filename and path keys (eg, a `%Plug.Upload{}`)\n\n  * A map with a filename and binary keys (eg, `%{filename: \"image.png\", binary: <<255,255,255,...>>}`)\n\n  * A two-element tuple consisting of one of the above file formats as well as a scope map\n\nExample usage as general file store:\n\n    # Store any locally accessible file\n    Avatar.store(\"/path/to/my/file.png\") #=> {:ok, \"file.png\"}\n\n    # Store any remotely accessible file\n    Avatar.store(\"http://example.com/file.png\") #=> {:ok, \"file.png\"}\n\n    # Store a file directly from a `%Plug.Upload{}`\n    Avatar.store(%Plug.Upload{filename: \"file.png\", path: \"/a/b/c\"}) #=> {:ok, \"file.png\"}\n\n    # Store a file from a connection body\n    {:ok, data, _conn} = Plug.Conn.read_body(conn)\n    Avatar.store(%{filename: \"file.png\", binary: data})\n\nExample usage as a file attached to a `scope`:\n\n    scope = Repo.get(User, 1)\n    Avatar.store({%Plug.Upload{}, scope}) #=> {:ok, \"file.png\"}\n\nThis scope will be available throughout the definition module to be\nused as an input to the storage parameters (eg, store files in\n`/uploads/#{scope.id}`).","ref":"Waffle.Actions.Store.html"},{"type":"function","title":"Waffle.Actions.Store.store/2","doc":"","ref":"Waffle.Actions.Store.html#store/2"},{"type":"module","title":"Waffle.Actions.Url","doc":"Url generation.\n\nSaving your files is only the first half of any decent storage\nsolution.  Straightforward access to your uploaded files is equally\nas important as storing them in the first place.\n\nOften times you will want to regain access to the stored files.  As\nsuch, `Waffle` facilitates the generation of urls.\n\n    # Given some user record\n    user = %{id: 1}\n\n    Avatar.store({%Plug.Upload{}, user}) #=> {:ok, \"selfie.png\"}\n\n    # To generate a regular, unsigned url (defaults to the first version):\n    Avatar.url({\"selfie.png\", user})\n    #=> \"https://bucket.s3.amazonaws.com/uploads/1/original.png\"\n\n    # To specify the version of the upload:\n    Avatar.url({\"selfie.png\", user}, :thumb)\n    #=> \"https://bucket.s3.amazonaws.com/uploads/1/thumb.png\"\n\n    # To generate a signed url:\n    Avatar.url({\"selfie.png\", user}, :thumb, signed: true)\n    #=> \"https://bucket.s3.amazonaws.com/uploads/1/thumb.png?AWSAccessKeyId=AKAAIPDF14AAX7XQ&Signature=5PzIbSgD1V2vPLj%2B4WLRSFQ5M%3D&Expires=1434395458\"\n\n    # To generate urls for all versions:\n    Avatar.urls({\"selfie.png\", user})\n    #=> %{original: \"https://.../original.png\", thumb: \"https://.../thumb.png\"}\n\n**Default url**\n\nIn cases where a placeholder image is desired when an uploaded file\nis not present, Waffle allows the definition of a default image to\nbe returned gracefully when requested with a `nil` file.\n\n    def default_url(version) do\n      MyApp.Endpoint.url <> \"/images/placeholders/profile_image.png\"\n    end\n\n    Avatar.url(nil) #=> \"http://example.com/images/placeholders/profile_image.png\"\n    Avatar.url({nil, scope}) #=> \"http://example.com/images/placeholders/profile_image.png\"\n\n**Virtual Host**\n\nTo support AWS regions other than US Standard, it may be required to\ngenerate urls in the\n[`virtual_host`](http://docs.aws.amazon.com/AmazonS3/latest/dev/VirtualHosting.html)\nstyle.  This will generate urls in the style:\n`https://#{bucket}.s3.amazonaws.com` instead of\n`https://s3.amazonaws.com/#{bucket}`.\n\nTo use this style of url generation, your bucket name must be DNS\ncompliant.\n\nThis can be enabled with:\n\n    config :waffle,\n      virtual_host: true\n\n> When using virtual hosted–style buckets with SSL, the SSL wild card certificate only matches buckets that do not contain periods. To work around this, use HTTP or write your own certificate verification logic.\n\n**Asset Host**\n\nYou may optionally specify an asset host rather than using the\ndefault `bucket.s3.amazonaws.com` format.\n\nIn your application configuration, you'll need to provide an `asset_host` value:\n\n    config :waffle,\n      asset_host: \"https://d3gav2egqolk5.cloudfront.net\", # For a value known during compilation\n      asset_host: {:system, \"ASSET_HOST\"} # For a value not known until runtime","ref":"Waffle.Actions.Url.html"},{"type":"function","title":"Waffle.Actions.Url.url/4","doc":"","ref":"Waffle.Actions.Url.html#url/4"},{"type":"module","title":"Waffle.Definition","doc":"Defines uploader to manage files.\n\n    defmodule Avatar do\n      use Waffle.Definition\n    end\n\nConsists of several components to manage different parts of file\nmanaging process.\n\n  * `Waffle.Definition.Versioning`\n\n  * `Waffle.Definition.Storage`\n\n  * `Waffle.Actions.Store`\n\n  * `Waffle.Actions.Delete`\n\n  * `Waffle.Actions.Url`","ref":"Waffle.Definition.html"},{"type":"module","title":"Waffle.Definition.Storage","doc":"Uploader configuration.\n\nAdd `use Waffle.Definition` inside your module to use it as uploader.","ref":"Waffle.Definition.Storage.html"},{"type":"module","title":"Storage directory - Waffle.Definition.Storage","doc":"By default, the storage directory is `uploads`. But, it can be customized\nin two ways.","ref":"Waffle.Definition.Storage.html#module-storage-directory"},{"type":"module","title":"By setting up configuration - Waffle.Definition.Storage","doc":"Customize storage directory via configuration option `:storage_dir`.\n\n    config :waffle,\n      storage_dir: \"my/dir\"","ref":"Waffle.Definition.Storage.html#module-by-setting-up-configuration"},{"type":"module","title":"By overriding the relevant functions in definition modules - Waffle.Definition.Storage","doc":"Every definition module has a default `storage_dir/2` which is overridable.\n\nFor example, a common pattern for user avatars is to store each user's\nuploaded images in a separate subdirectory based on primary key:\n\n    def storage_dir(version, {file, scope}) do\n      \"uploads/users/avatars/#{scope.id}\"\n    end\n\n> **Note**: If you are \"attaching\" a file to a record on creation (eg, while inserting the record at the same time), then you cannot use the model's `id` as a path component.  You must either (1) use a different storage path format, such as UUIDs, or (2) attach and update the model after an id has been given. [Read more about how to integrate it with Ecto](https://hexdocs.pm/waffle_ecto/filepath-with-id.html#content)\n\n> **Note**: The storage directory is used for both local filestorage (as the relative or absolute directory), and S3 storage, as the path name (not including the bucket).","ref":"Waffle.Definition.Storage.html#module-by-overriding-the-relevant-functions-in-definition-modules"},{"type":"module","title":"Asynchronous File Uploading - Waffle.Definition.Storage","doc":"If you specify multiple versions in your definition module, each\nversion is processed and stored concurrently as independent Tasks.\nTo prevent an overconsumption of system resources, each Task is\ngiven a specified timeout to wait, after which the process will\nfail.  By default, the timeout is `15_000` milliseconds.\n\nIf you wish to change the time allocated to version transformation\nand storage, you can add a configuration option:\n\n    config :waffle,\n      :version_timeout, 15_000 # milliseconds\n\nTo disable asynchronous processing, add `@async false` to your\ndefinition module.","ref":"Waffle.Definition.Storage.html#module-asynchronous-file-uploading"},{"type":"module","title":"Storage of files - Waffle.Definition.Storage","doc":"Waffle currently supports:\n\n  * `Waffle.Storage.Local`\n  * `Waffle.Storage.S3`\n\nOverride the `__storage` function in your definition module if you\nwant to use a different type of storage for a particular uploader.","ref":"Waffle.Definition.Storage.html#module-storage-of-files"},{"type":"module","title":"File Validation - Waffle.Definition.Storage","doc":"While storing files on S3 eliminates some malicious attack vectors,\nit is strongly encouraged to validate the extensions of uploaded\nfiles as well.\n\nWaffle delegates validation to a `validate/1` function with a tuple\nof the file and scope.  As an example, in order to validate that an\nuploaded file conforms to popular image formats, you can use:\n\n    defmodule Avatar do\n      use Waffle.Definition\n      @extension_whitelist ~w(.jpg .jpeg .gif .png)\n\n      def validate({file, _}) do\n        file_extension = file.file_name |> Path.extname() |> String.downcase()\n\n        case Enum.member?(@extension_whitelist, file_extension) do\n          true -> :ok\n          false -> {:error, \"invalid file type\"}\n        end\n      end\n    end\n\nValidation will be considered successful if the function returns `true` or `:ok`.\nA customized error message can be returned in the form of `{:error, message}`.\nAny other return value will return `{:error, :invalid_file}` when passed through\nto `Avatar.store`.","ref":"Waffle.Definition.Storage.html#module-file-validation"},{"type":"module","title":"Passing custom headers when downloading from remote path - Waffle.Definition.Storage","doc":"By default, when downloading files from remote path request headers are empty,\nbut if you wish to provide your own, you can override the `remote_file_headers/1`\nfunction in your definition module. For example:\n\n    defmodule Avatar do\n      use Waffle.Definition\n\n      def remote_file_headers(%URI{host: \"elixir-lang.org\"}) do\n        credentials = Application.get_env(:my_app, :avatar_credentials)\n        token = Base.encode64(credentials[:username] <> \":\" <> credentials[:password])\n\n        [{\"Authorization\", \"Basic #{token}\")}]\n      end\n    end\n\nThis code would authenticate request only for specific domain. Otherwise, it would send\nempty request headers.","ref":"Waffle.Definition.Storage.html#module-passing-custom-headers-when-downloading-from-remote-path"},{"type":"module","title":"Waffle.Definition.Versioning","doc":"Define proper name for a version.\n\nIt may be undesirable to retain original filenames (eg, it may\ncontain personally identifiable information, vulgarity,\nvulnerabilities with Unicode characters, etc).\n\nYou may specify the destination filename for uploaded versions\nthrough your definition module.\n\nA common pattern is to combine directories scoped to a particular\nmodel's primary key, along with static filenames. (eg:\n`user_avatars/1/thumb.png`).\n\n    # To retain the original filename, but prefix the version and user id:\n    def filename(version, {file, scope}) do\n      file_name = Path.basename(file.file_name, Path.extname(file.file_name))\n      \"#{scope.id}_#{version}_#{file_name}\"\n    end\n\n    # To make the destination file the same as the version:\n    def filename(version, _), do: version","ref":"Waffle.Definition.Versioning.html"},{"type":"function","title":"Waffle.Definition.Versioning.resolve_file_name/3","doc":"","ref":"Waffle.Definition.Versioning.html#resolve_file_name/3"},{"type":"module","title":"Waffle.Processor","doc":"Apply transformation to files.\n\nWaffle can be used to facilitate transformations of uploaded files\nvia any system executable.  Some common operations you may want to\ntake on uploaded files include resizing an uploaded avatar with\nImageMagick or extracting a still image from a video with FFmpeg.\n\nTo transform an image, the definition module must define a\n`transform/2` function which accepts a version atom and a tuple\nconsisting of the uploaded file and corresponding scope.\n\nThis transform handler accepts the version atom, as well as the\nfile/scope argument, and is responsible for returning one of the\nfollowing:\n\n  * `:noaction` - The original file will be stored as-is.\n\n  * `:skip` - Nothing will be stored for the provided version.\n\n  * `{executable, args}` - The `executable` will be called with\n    `System.cmd` with the format\n    `#{original_file_path} #{args} #{transformed_file_path}`.\n\n  * `{executable, fn(input, output) -> args end}` If your executable\n    expects arguments in a format other than the above, you may\n    supply a function to the conversion tuple which will be invoked\n    to generate the arguments. The arguments can be returned as a\n    string (e.g. – `\" #{input} -strip -thumbnail 10x10 #{output}\"`)\n    or a list (e.g. – `[input, \"-strip\", \"-thumbnail\", \"10x10\",\n    output]`) for even more control.\n\n  * `{executable, args, output_extension}` - If your transformation\n    changes the file extension (eg, converting to `png`), then the\n    new file extension must be explicit.\n\n  * `fn version, file -> {:ok, file} end` - Implement custom\n    transformation as elixir function,\n    [read more about custom transformations](custom_transformation.livemd)\n\n  * `{&transform/2, fn version, file -> :png end}` - A custom\n    transformation converting a file into a different extension","ref":"Waffle.Processor.html"},{"type":"module","title":"ImageMagick transformations - Waffle.Processor","doc":"As images are one of the most commonly uploaded filetypes, Waffle\nhas a recommended integration with ImageMagick's `convert` tool for\nmanipulation of images.  Each definition module may specify as many\nversions as desired, along with the corresponding transformation for\neach version.\n\nThe expected return value of a `transform` function call must either\nbe `:noaction`, in which case the original file will be stored\nas-is, `:skip`, in which case nothing will be stored, or `{:convert,\ntransformation}` in which the original file will be processed via\nImageMagick's `convert` tool with the corresponding transformation\nparameters.\n\nThe following example stores the original file, as well as a squared\n100x100 thumbnail version which is stripped of comments (eg, GPS\ncoordinates):\n\n    defmodule Avatar do\n      use Waffle.Definition\n\n      @versions [:original, :thumb]\n\n      def transform(:thumb, _) do\n        {:convert, \"-strip -thumbnail 100x100^ -gravity center -extent 100x100\"}\n      end\n    end\n\nOther examples:\n\n    # Change the file extension through ImageMagick's `format` parameter:\n    {:convert, \"-strip -thumbnail 100x100^ -gravity center -extent 100x100 -format png\", :png}\n\n    # Take the first frame of a gif and process it into a square jpg:\n    {:convert, fn(input, output) -> \"#{input}[0] -strip -thumbnail 100x100^ -gravity center -extent 100x100 -format jpg #{output}\", :jpg}\n\nFor more information on defining your transformation, please consult\n[ImageMagick's convert\ndocumentation](http://www.imagemagick.org/script/convert.php).\n\n> **Note**: Keep this transformation function simple and deterministic based on the version, file name, and scope object. The `transform` function is subsequently called during URL generation, and the transformation is scanned for the output file format.  As such, if you conditionally format the image as a `png` or `jpg` depending on the time of day, you will be displeased with the result of Waffle's URL generation.\n\n> **System Resources**: If you are accepting arbitrary uploads on a public site, it may be prudent to add system resource limits to prevent overloading your system resources from malicious or nefarious files.  Since all processing is done directly in ImageMagick, you may pass in system resource restrictions through the [-limit](http://www.imagemagick.org/script/command-line-options.php#limit) flag.  One such example might be: `-limit area 10MB -limit disk 100MB`.","ref":"Waffle.Processor.html#module-imagemagick-transformations"},{"type":"module","title":"FFmpeg transformations - Waffle.Processor","doc":"Common transformations of uploaded videos can be also defined\nthrough your definition module:\n\n    # To take a thumbnail from a video:\n    {:ffmpeg, fn(input, output) -> \"-i #{input} -f jpg #{output}\" end, :jpg}\n\n    # To convert a video to an animated gif\n    {:ffmpeg, fn(input, output) -> \"-i #{input} -f gif #{output}\" end, :gif}","ref":"Waffle.Processor.html#module-ffmpeg-transformations"},{"type":"module","title":"Complex Transformations - Waffle.Processor","doc":"`Waffle` requires the output of your transformation to be located at\na predetermined path.  However, the transformation may be done\ncompletely outside of `Waffle`. For fine-grained transformations,\nyou should create an executable wrapper in your $PATH (eg. bash\nscript) which takes these proper arguments, runs your\ntransformation, and then moves the file into the correct location.\n\nFor example, to use `soffice` to convert a doc to an html file, you\nshould place the following bash script in your $PATH:\n\n    #!/usr/bin/env sh\n\n    # `soffice` doesn't allow for output file path option, and waffle can't find the\n    # temporary file to process and copy. This script has a similar argument list as\n    # what waffle expects. See https://github.com/stavro/arc/issues/77.\n\n    set -e\n    set -o pipefail\n\n    function convert {\n        soffice \\\n            --headless \\\n            --convert-to html \\\n            --outdir $TMPDIR \\\n            \"$1\"\n    }\n\n    function filter_new_file_name {\n        awk -F$TMPDIR '{print $2}' \\\n        | awk -F\" \" '{print $1}' \\\n        | awk -F/ '{print $2}'\n    }\n\n    converted_file_name=$(convert \"$1\" | filter_new_file_name)\n\n    cp $TMPDIR/$converted_file_name \"$2\"\n    rm $TMPDIR/$converted_file_name\n\nAnd perform the transformation as such:\n\n    def transform(:html, _) do\n      {:soffice_wrapper, fn(input, output) -> [input, output] end, :html}\n    end","ref":"Waffle.Processor.html#module-complex-transformations"},{"type":"function","title":"Waffle.Processor.process/3","doc":"","ref":"Waffle.Processor.html#process/3"},{"type":"module","title":"Waffle.Storage.Local","doc":"Local storage provides facility to store files locally.","ref":"Waffle.Storage.Local.html"},{"type":"module","title":"Local configuration - Waffle.Storage.Local","doc":"config :waffle,\n      storage: Waffle.Storage.Local,\n      # in order to have a different storage directory from url\n      storage_dir_prefix: \"priv/waffle/private\",\n      # add custom host to url\n      asset_host: \"https://example.com\"\n\nIf you want to handle your attachments by phoenix application,\nconfigure the endpoint to serve it.\n\n    defmodule AppWeb.Endpoint do\n      plug Plug.Static,\n        at: \"/uploads\",\n        from: Path.expand(\"./priv/waffle/public/uploads\"),\n        gzip: false\n    end","ref":"Waffle.Storage.Local.html#module-local-configuration"},{"type":"function","title":"Waffle.Storage.Local.delete/3","doc":"","ref":"Waffle.Storage.Local.html#delete/3"},{"type":"function","title":"Waffle.Storage.Local.put/3","doc":"","ref":"Waffle.Storage.Local.html#put/3"},{"type":"function","title":"Waffle.Storage.Local.url/4","doc":"","ref":"Waffle.Storage.Local.html#url/4"},{"type":"module","title":"Waffle.Storage.S3","doc":"The module to facilitate integration with S3 through ExAws.S3\n\n    config :waffle,\n      storage: Waffle.Storage.S3,\n      bucket: {:system, \"AWS_S3_BUCKET\"}\n\nAlong with any configuration necessary for ExAws.\n\n[ExAws](https://github.com/CargoSense/ex_aws) is used to support Amazon S3.\n\nTo store your attachments in Amazon S3, you'll need to provide a\nbucket destination in your application config:\n\n    config :waffle,\n      bucket: \"uploads\"\n\nYou may also set the bucket from an environment variable:\n\n    config :waffle,\n      bucket: {:system, \"S3_BUCKET\"}\n\nIn addition, ExAws must be configured with the appropriate Amazon S3\ncredentials.\n\nExAws has by default the following configuration (which you may\noverride if you wish):\n\n    config :ex_aws,\n      json_codec: Jason,\n      access_key_id: [{:system, \"AWS_ACCESS_KEY_ID\"}, :instance_role],\n      secret_access_key: [{:system, \"AWS_SECRET_ACCESS_KEY\"}, :instance_role]\n\nThis means it will first look for the AWS standard\n`AWS_ACCESS_KEY_ID` and `AWS_SECRET_ACCESS_KEY` environment\nvariables, and fall back using instance meta-data if those don't\nexist. You should set those environment variables to your\ncredentials, or configure an instance that this library runs on to\nhave an iam role.","ref":"Waffle.Storage.S3.html"},{"type":"module","title":"Specify multiple buckets - Waffle.Storage.S3","doc":"Waffle lets you specify a bucket on a per definition basis. In case\nyou want to use multiple buckets, you can specify a bucket in the\ndefinition module like this:\n\n    def bucket, do: :some_custom_bucket_name\n\nYou can also use the current scope to define a target bucket\n\n    def bucket({_file, scope}), do: scope.bucket || bucket()","ref":"Waffle.Storage.S3.html#module-specify-multiple-buckets"},{"type":"module","title":"Access Control Permissions - Waffle.Storage.S3","doc":"Waffle defaults all uploads to `private`.  In cases where it is\ndesired to have your uploads public, you may set the ACL at the\nmodule level (which applies to all versions):\n\n    @acl :public_read\n\nOr you may have more granular control over each version.  As an\nexample, you may wish to explicitly only make public a thumbnail\nversion of the file:\n\n    def acl(:thumb, _), do: :public_read\n\nSupported access control lists for Amazon S3 are:\n\n| ACL                          | Permissions Added to ACL                                                        |\n|------------------------------|---------------------------------------------------------------------------------|\n| `:private`                   | Owner gets `FULL_CONTROL`. No one else has access rights (default).             |\n| `:public_read`               | Owner gets `FULL_CONTROL`. The `AllUsers` group gets READ access.               |\n| `:public_read_write`         | Owner gets `FULL_CONTROL`. The `AllUsers` group gets `READ` and `WRITE` access. |\n|                              | Granting this on a bucket is generally not recommended.                         |\n| `:authenticated_read`        | Owner gets `FULL_CONTROL`. The `AuthenticatedUsers` group gets `READ` access.   |\n| `:bucket_owner_read`         | Object owner gets `FULL_CONTROL`. Bucket owner gets `READ` access.              |\n| `:bucket_owner_full_control` | Both the object owner and the bucket owner get `FULL_CONTROL` over the object.  |\n\nFor more information on the behavior of each of these, please\nconsult Amazon's documentation for [Access Control List (ACL)\nOverview](https://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html).","ref":"Waffle.Storage.S3.html#module-access-control-permissions"},{"type":"module","title":"S3 Object Headers - Waffle.Storage.S3","doc":"The definition module may specify custom headers to pass through to\nS3 during object creation.  The available custom headers include:\n\n  *  `:cache_control`\n  *  `:content_disposition`\n  *  `:content_encoding`\n  *  `:content_length`\n  *  `:content_type`\n  *  `:expect`\n  *  `:expires`\n  *  `:storage_class`\n  *  `:website_redirect_location`\n  *  `:encryption` (set to \"AES256\" for encryption at rest)\n\nAs an example, to explicitly specify the content-type of an object,\nyou may define a `s3_object_headers/2` function in your definition,\nwhich returns a Keyword list, or Map of desired headers.\n\n    def s3_object_headers(version, {file, scope}) do\n      [content_type: MIME.from_path(file.file_name)] # for \"image.png\", would produce: \"image/png\"\n    end","ref":"Waffle.Storage.S3.html#module-s3-object-headers"},{"type":"module","title":"Alternate S3 configuration example - Waffle.Storage.S3","doc":"If you are using a region other than US-Standard, it is necessary to\nspecify the correct configuration for `ex_aws`.  A full example\nconfiguration for both waffle and ex_aws is as follows:\n\n    config :waffle,\n      bucket: \"my-frankfurt-bucket\"\n\n    config :ex_aws,\n      json_codec: Jason,\n      access_key_id: \"my_access_key_id\",\n      secret_access_key: \"my_secret_access_key\",\n      region: \"eu-central-1\",\n      s3: [\n        scheme: \"https://\",\n        host: \"s3.eu-central-1.amazonaws.com\",\n        region: \"eu-central-1\"\n      ]\n\n> For your host configuration, please examine the approved [AWS Hostnames](http://docs.aws.amazon.com/general/latest/gr/rande.html).  There are often multiple hostname formats for AWS regions, and it will not work unless you specify the correct one.","ref":"Waffle.Storage.S3.html#module-alternate-s3-configuration-example"},{"type":"function","title":"Waffle.Storage.S3.delete/3","doc":"","ref":"Waffle.Storage.S3.html#delete/3"},{"type":"function","title":"Waffle.Storage.S3.put/3","doc":"","ref":"Waffle.Storage.S3.html#put/3"},{"type":"function","title":"Waffle.Storage.S3.s3_key/3","doc":"","ref":"Waffle.Storage.S3.html#s3_key/3"},{"type":"function","title":"Waffle.Storage.S3.url/4","doc":"","ref":"Waffle.Storage.S3.html#url/4"},{"type":"exception","title":"Waffle.MissingExecutableError","doc":"","ref":"Waffle.MissingExecutableError.html"},{"type":"extras","title":"Waffle","doc":"[hex-img]: http://img.shields.io/hexpm/v/waffle.svg\n\n[hexdocs-img]: http://img.shields.io/badge/hexdocs-documentation-brightgreen.svg\n\n[evrone-img]: https://img.shields.io/badge/Sponsored_by-Evrone-brightgreen.svg\n\n# Waffle [![Sponsored by Evrone][evrone-img]](https://evrone.com?utm_source=waffle)\n\n[![Hex.pm Version][hex-img]](https://hex.pm/packages/waffle)\n[![waffle documentation][hexdocs-img]](https://hexdocs.pm/waffle)\n\n![Waffle is a flexible file upload library for Elixir](https://elixir-waffle.github.io/waffle/assets/logo.svg)\n\nWaffle is a flexible file upload library for Elixir with straightforward integrations for Amazon S3 and ImageMagick.\n\n[Documentation](https://hexdocs.pm/waffle)","ref":"readme.html"},{"type":"extras","title":"Installation - Waffle","doc":"Add the latest stable release to your `mix.exs` file, along with the\nrequired dependencies for `ExAws` if appropriate:\n\n```elixir\ndefp deps do\n  [\n    {:waffle, \"~> 1.1\"},\n\n    # If using S3:\n    {:ex_aws, \"~> 2.1.2\"},\n    {:ex_aws_s3, \"~> 2.0\"},\n    {:hackney, \"~> 1.9\"},\n    {:sweet_xml, \"~> 0.6\"}\n  ]\nend\n```\n\nThen run `mix deps.get` in your shell to fetch the dependencies.","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Waffle","doc":"After installing Waffle, another two things should be done:\n\n1. setup a storage provider\n2. define a definition module","ref":"readme.html#usage"},{"type":"extras","title":"Setup a storage provider - Waffle","doc":"Waffle has two built-in storage providers:\n\n* `Waffle.Storage.Local`\n* `Waffle.Storage.S3`\n\n[Other available storage providers](#other-storage-providers)\nare supported by the community.\n\nAn example for setting up `Waffle.Storage.Local`:\n\n```elixir\nconfig :waffle,\n  storage: Waffle.Storage.Local,\n  asset_host: \"http://static.example.com\" # or {:system, \"ASSET_HOST\"}\n```\n\nAn example for setting up `Waffle.Storage.S3`:\n\n```elixir\nconfig :waffle,\n  storage: Waffle.Storage.S3,\n  bucket: \"custom_bucket\",                # or {:system, \"AWS_S3_BUCKET\"}\n  asset_host: \"http://static.example.com\" # or {:system, \"ASSET_HOST\"}\n\nconfig :ex_aws,\n  json_codec: Jason\n  # any configurations provided by https://github.com/ex-aws/ex_aws\n```","ref":"readme.html#setup-a-storage-provider"},{"type":"extras","title":"Define a definition module - Waffle","doc":"Waffle requires a **definition module** which contains the relevant\nfunctions to store and retrieve files:\n\n* Optional transformations of the uploaded file\n* Where to put your files (the storage directory)\n* How to name your files\n* How to secure your files (private? Or publicly accessible?)\n* Default placeholders\n\nThis module can be created manually or generated by `mix waffle.g`\nautomatically.\n\nAs an example, we will generate a definition module for handling\navatars:\n\n    mix waffle.g avatar\n\nThis should generate a file at `lib/[APP_NAME]_web/uploaders/avatar.ex`.\nCheck this file for descriptions of configurable options.","ref":"readme.html#define-a-definition-module"},{"type":"extras","title":"Examples - Waffle","doc":"* [An example for Local storage driver](documentation/examples/local.md)\n* [An example for S3 storage driver](documentation/examples/s3.md)","ref":"readme.html#examples"},{"type":"extras","title":"Usage with Ecto - Waffle","doc":"Waffle comes with a companion package for use with Ecto. If you\nintend to use Waffle with Ecto, it is highly recommended you also\nadd the\n[`waffle_ecto`](https://github.com/elixir-waffle/waffle_ecto)\ndependency.  Benefits include:\n\n  * Changeset integration\n  * Versioned urls for cache busting (`.../thumb.png?v=63601457477`)","ref":"readme.html#usage-with-ecto"},{"type":"extras","title":"Other Storage Providers - Waffle","doc":"* **Rackspace** - [arc_rackspace](https://github.com/lokalebasen/arc_rackspace)\n\n  * **Manta** - [arc_manta](https://github.com/onyxrev/arc_manta)\n\n  * **OVH** - [arc_ovh](https://github.com/stephenmoloney/arc_ovh)\n\n  * **Google Cloud Storage** - [waffle_gcs](https://github.com/elixir-waffle/waffle_gcs)\n\n  * **Microsoft Azure Storage** - [arc_azure](https://github.com/phil-a/arc_azure)\n\n  * **Aliyun OSS Storage** - [waffle_aliyun_oss](https://github.com/ug0/waffle_aliyun_oss)","ref":"readme.html#other-storage-providers"},{"type":"extras","title":"Testing - Waffle","doc":"The basic test suite can be run with without supplying any S3 information:\n\n```\nmix test\n```\n\nIn order to test S3 capability, you must have access to an S3/equivalent bucket. For\nS3 buckets, the bucket must be configured to allow ACLs and it must allow public\naccess.\n\nThe following environment variables will be used by the test suite:\n\n* WAFFLE_TEST_BUCKET\n* WAFFLE_TEST_BUCKET2\n* WAFFLE_TEST_S3_KEY\n* WAFFLE_TEST_S3_SECRET\n* WAFFLE_TEST_REGION\n\nAfter setting these variables, you can run the full test suite with `mix test --include s3:true`.","ref":"readme.html#testing"},{"type":"extras","title":"Attribution - Waffle","doc":"Great thanks to Sean Stavropoulos (@stavro) for the original awesome work on the library.\n\nThis project is forked from [Arc](https://github.com/stavro/arc) from the version `v0.11.0`.","ref":"readme.html#attribution"},{"type":"extras","title":"License - Waffle","doc":"Copyright 2019 Boris Kuznetsov  \n\nCopyright 2015 Sean Stavropoulos\n\n  Licensed under the Apache License, Version 2.0 (the \"License\");\n  you may not use this file except in compliance with the License.\n  You may obtain a copy of the License at\n\n      http://www.apache.org/licenses/LICENSE-2.0\n\n  Unless required by applicable law or agreed to in writing, software\n  distributed under the License is distributed on an \"AS IS\" BASIS,\n  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n  See the License for the specific language governing permissions and\n  limitations under the License.","ref":"readme.html#license"},{"type":"extras","title":"An Example for Local","doc":"# An Example for Local\n\nSetup the storage provider:\n```elixir\nconfig :waffle,\n  storage: Waffle.Storage.Local,\n  asset_host: \"http://static.example.com\" # or {:system, \"ASSET_HOST\"}\n```\n\nDefine a definition module:\n```elixir\ndefmodule Avatar do\n  use Waffle.Definition\n\n  @versions [:original, :thumb]\n  @extensions ~w(.jpg .jpeg .gif .png)\n\n  def validate({file, _}) do\n    file_extension = file.file_name |> Path.extname |> String.downcase\n\n    case Enum.member?(@extensions, file_extension) do\n      true -> :ok\n      false -> {:error, \"file type is invalid\"}\n    end\n  end\n\n  def transform(:thumb, _) do\n    {:convert, \"-thumbnail 100x100^ -gravity center -extent 100x100 -format png\", :png}\n  end\n\n  def filename(version, _) do\n    version\n  end\n\n  def storage_dir(_, {file, user}) do\n    \"uploads/avatars/#{user.id}\"\n  end\nend\n```\n\nStore or Get files:\n```elixir\n# Given some current_user record\ncurrent_user = %{id: 1}\n\n# Store any accessible file\nAvatar.store({\"/path/to/my/selfie.png\", current_user})\n#=> {:ok, \"selfie.png\"}\n\n# ..or store directly from the `params` of a file upload within your controller\nAvatar.store({%Plug.Upload{}, current_user})\n#=> {:ok, \"selfie.png\"}\n\n# and retrieve the url later\nAvatar.url({\"selfie.png\", current_user}, :thumb)\n#=> \"uploads/avatars/1/thumb.png\"\n```","ref":"local.html"},{"type":"extras","title":"An Example for S3","doc":"# An Example for S3\n\nSetup the storage provider:\n```elixir\nconfig :waffle,\n  storage: Waffle.Storage.S3,\n  bucket: \"custom_bucket\",                # or {:system, \"AWS_S3_BUCKET\"}\n  asset_host: \"http://static.example.com\" # or {:system, \"ASSET_HOST\"}\n\nconfig :ex_aws,\n  json_codec: Jason\n  # any configurations provided by https://github.com/ex-aws/ex_aws\n```\n\nDefine a definition module:\n```elixir\ndefmodule Avatar do\n  use Waffle.Definition\n\n  @versions [:original, :thumb]\n  @extension_whitelist ~w(.jpg .jpeg .gif .png)\n\n  def acl(:thumb, _), do: :public_read\n\n  def validate({file, _}) do\n    file_extension = file.file_name |> Path.extname |> String.downcase\n    Enum.member?(@extension_whitelist, file_extension)\n  end\n\n  def transform(:thumb, _) do\n    {:convert, \"-thumbnail 100x100^ -gravity center -extent 100x100 -format png\", :png}\n  end\n\n  def filename(version, _) do\n    version\n  end\n\n  def storage_dir(_, {file, user}) do\n    \"uploads/avatars/#{user.id}\"\n  end\n\n  def default_url(:thumb) do\n    \"https://placehold.it/100x100\"\n  end\nend\n```\n\nStore or Get files:\n```elixir\n# Given some current_user record\ncurrent_user = %{id: 1}\n\n# Store any accessible file\nAvatar.store({\"/path/to/my/selfie.png\", current_user})\n#=> {:ok, \"selfie.png\"}\n\n# ..or store directly from the `params` of a file upload within your controller\nAvatar.store({%Plug.Upload{}, current_user})\n#=> {:ok, \"selfie.png\"}\n\n# and retrieve the url later\nAvatar.url({\"selfie.png\", current_user}, :thumb)\n#=> \"https://s3.amazonaws.com/custom_bucket/uploads/avatars/1/thumb.png\"\n```","ref":"s3.html"},{"type":"extras","title":"Processing with custom functions","doc":"# Processing with custom functions\n\n```elixir\nlib =\n  Regex.named_captures(~r/(? .+)documentation\\/livebooks/, __DIR__)\n  |> Map.get(\"lib\")\n\nMix.install([\n  # for local development\n  # {:waffle, path: lib}\n  :waffle\n])\n```","ref":"custom_transformation.html"},{"type":"extras","title":"Definition - Processing with custom functions","doc":"All starts from creating the definition and custom processing function\n\n```elixir\ndefmodule Avatar do\n  use Waffle.Definition\n  @versions [:original, :thumb]\n\n  def __storage, do: Waffle.Storage.Local\n\n  def filename(version, _), do: version\n\n  def transform(:thumb, _) do\n    &process/2\n  end\n\n  @spec process(\n          atom(),\n          Waffle.File.t()\n        ) :: {:ok, Waffle.File.t()} | {:error, String.t()}\n  def process(_version, original_file) do\n    {:ok, file}\n  end\nend\n```\n\nThen, you can store the file by calling `Avatar.store/1`\n\n```elixir\nimage = lib <> \"test/support/image.png\"\n\nAvatar.store(image)\n```","ref":"custom_transformation.html#definition"},{"type":"extras","title":"Understanding custom transformations - Processing with custom functions","doc":"<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\ndef process(_version, original_file) do\n  {:ok, file}\nend\n```\n\nTo generate a temporary path for the new file version\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\ntmp_path = Waffle.File.generate_temporary_path(file)\n```\n\nor if the new version is going to have a new extension\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\ntmp_path = Waffle.File.generate_temporary_path(\"png\")\n```\n\nthen, you can process your file and put the result into tmp_path.\n\nTo return the processed tmp file into the pipeline and clean it afterwards, create a new file struct\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\n{:ok, %Waffle.File{file | path: tmp_path, is_tempfile?: true}}\n```\n\nYou can combine it all together to use `ExOptimizer` library\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\ndef process(_version, original_file) do\n  tmp_path = Waffle.File.generate_temporary_path(original_file)\n\n  File.cp!(original_file.path, tmp_path)\n\n  with {:ok, _} <- ExOptimizer.optimize(tmp_path) do\n    {\n      :ok,\n      %Waffle.File{original_file | path: tmp_path, is_tempfile?: true}\n    }\n  end\nend\n```","ref":"custom_transformation.html#understanding-custom-transformations"},{"type":"extras","title":"All together - Processing with custom functions","doc":"We can create a bit more complex example, where we combine transformation done by external binary with transformation done by existing elixir library.\n\n```elixir\ndefmodule Avatar do\n  use Waffle.Definition\n  @versions [:original, :thumb]\n\n  def __storage, do: Waffle.Storage.Local\n\n  def filename(version, _), do: version\n\n  def transform(:thumb, _) do\n    &process/2\n  end\n\n  @spec process(\n          atom(),\n          Waffle.File.t()\n        ) :: {:ok, Waffle.File.t()} | {:error, String.t()}\n  def process(_version, original_file) do\n    # convert .jpg to .png\n    args = \"-strip -thumbnail 100x100^ -gravity center -extent 100x100 -format png\"\n\n    with {:ok, file} <-\n           Waffle.Transformations.Convert.apply(\n             :convert,\n             original_file,\n             args,\n             :png\n           ),\n         {:ok, _} <- ExOptimizer.optimize(file.path) do\n      {:ok, file}\n    end\n  end\nend\n```","ref":"custom_transformation.html#all-together"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}